declare class HyperFunctionComponent {
  static propTypes?: HfcPropTypes;
  constructor(props: HfcProps);

  connected(container: HTMLDivElement): void;
  changed?(
    type: "attr" | "event" | "slot",
    name: string,
    oldValue: any,
    newValue: any
  ): void;
  disconnected?(): void;
}

declare interface HfcProps {
  attrs: { [k: string]: any };
  events: { [k: string]: (args?: { [k: string]: any }) => any };
  slots: {
    [k: string]: (container: HTMLElement, args?: { [k: string]: any }) => void;
  };
}

declare interface HfcPropTypes {
  attrs?: { [k: string]: HfcPropTypeDef };
  events?: { [k: string]: { [k: string]: HfcPropTypeDef } };
  slots?: { [k: string]: { [k: string]: HfcPropTypeDef } };
}

declare type HfcPropTypeDef = any;
